<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>G-CTMQC: /Users/agostini/Documents/RELEASED_GCTMQC/g-ctmqc/src/output.f90 Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">G-CTMQC
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('output_8f90_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">output.f90</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">!------------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">! G-CTMQC code version 1.0                                                     !</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">!------------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">!                                                                              !</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">! AUTHOR: Federica Agostini, Institut de Chimie Physique, Paris-Saclay.        !</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">!                                                                              !</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">! MODULE: output                                                               !</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">! Free software: you can redistribute it and/or modify it under the terms of   !</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">!                the GNU Lesser General Public License as published by the     !</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">!                Free Software Foundation, either version 3 of the License, or !</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">!                (at your choice) any later version.                           !</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">!                                                                              !</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">! DESCRIPTION: Calls to various subroutines that output results along the      !</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">! the dynamics.                                                                !</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">!                                                                              !</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">! REVISION HISTORY: 11/03/2021 - Initial Version                               !</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">!                                                                              !</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">!------------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="namespaceoutput.html">   24</a></span>&#160;<span class="keyword">MODULE</span> <a class="code" href="namespaceoutput.html">output</a></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;  <span class="keywordtype">USE </span><a class="code" href="namespacevariables.html">variables</a></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;  <span class="keywordtype">USE </span><a class="code" href="namespacekinds.html">kinds</a></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;  <span class="keywordtype">USE </span><a class="code" href="namespaceanalytical__potentials.html">analytical_potentials</a></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  <span class="keywordtype">IMPLICIT NONE</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;  <span class="keyword">CONTAINS</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;  <span class="comment">! DESCRIPTION: General output subroutine                                    !</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="namespaceoutput.html#a97d7611603ef98cdf4434e93ae5ea38d">   48</a></span>&#160;  <span class="keyword">SUBROUTINE </span>plot(BOsigma,Rcl,Vcl,time)</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">INTEGER</span>         ,<span class="keywordtype">INTENT(IN)</span>    :: time</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keywordtype">    REAL</span>(KIND=dp)   ,<span class="keywordtype">INTENT(IN)</span>    :: rcl(ntraj,n_dof),vcl(ntraj,n_dof)</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">COMPLEX(KIND=QP)</span>,<span class="keywordtype">INTENT(IN)</span>    :: BOsigma(ntraj,nstates,nstates)</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">INTEGEr</span>                        :: i,j,itraj,index_ij</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordflow">IF</span>(time==0 .AND. new_potential) <span class="keyword">CALL </span>plot_potential</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">CALL </span>plot_coefficients(bosigma,rcl,time)</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordflow">DO</span> itraj=1,ntraj</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;      <span class="keyword">CALL </span>compute_energy(bosigma(itraj,:,:),boenergy(itraj,:),itraj)</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keywordflow">    END DO</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">CALL </span>plot_r_p_e(rcl,vcl,time)</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">IF</span>(time==0) <span class="keyword">CALL </span>initialize_output</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    bo_pop = 0.0_dp</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    bo_pop_sh = 0.0_dp</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordflow">IF</span> (typ_cal==<span class="stringliteral">&quot;TSHLZ&quot;</span> .OR. typ_cal==<span class="stringliteral">&quot;TSHFS&quot;</span>) <span class="keywordflow">THEN</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;       <span class="keywordflow">DO</span> i=1,nstates</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;          <span class="keywordflow">DO</span> itraj=1,ntraj</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;             <span class="keywordflow">IF</span> (occ_state(itraj)==i) bo_pop_sh(i) = bo_pop_sh(i) + 1_dp </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keywordflow">          END DO</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="keywordflow">       END DO</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;       bo_pop_sh = bo_pop_sh/dble(ntraj)</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="keywordflow">    END IF</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordflow">DO</span> itraj=1,ntraj</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;       <span class="keywordflow">DO</span> i=1,nstates</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;          bo_pop(i) = bo_pop(i) + real(bosigma(itraj,i,i),kind=dp)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keywordflow">       END DO</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="keywordflow">    END DO</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;  </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    bo_pop = bo_pop/dble(ntraj)</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    bo_coh   = 0.0_dp</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    index_ij = 0</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordflow">DO</span> i=1,nstates</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;       <span class="keywordflow">DO</span> j=i+1,nstates</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;          index_ij=index_ij+1</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;          <span class="keywordflow">DO</span> itraj=1,ntraj</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;             bo_coh(index_ij) = bo_coh(index_ij) + &amp;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;               (real(bosigma(itraj,i,i),kind=dp))* &amp;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;               (real(bosigma(itraj,j,j),kind=dp))</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="keywordflow">          END DO</span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keywordflow">       END DO</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="keywordflow">    END DO</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    bo_coh = bo_coh/dble(ntraj)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keyword">WRITE</span>(88,<span class="stringliteral">&#39;(f14.4,100f14.8)&#39;</span>) dble(time)*dt,bo_coh</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keyword">WRITE</span>(89,<span class="stringliteral">&#39;(f14.4,100f14.8)&#39;</span>) dble(time)*dt,bo_pop,bo_pop_sh</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordflow">IF</span>(time==nsteps) <span class="keyword">CALL </span>finalize_output</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160; </div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;  <span class="keyword">END SUBROUTINE </span>plot</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;  <span class="comment">! DESCRIPTION: Output subroutine for electronic coefficients                !</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="namespaceoutput.html#ac9b4106993ba0f3f342033fbb3965daa">  121</a></span>&#160;  <span class="keyword">SUBROUTINE </span>plot_coefficients(BOsigma,Rcl,time)</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="keywordtype">INTEGER</span>,<span class="keywordtype">INTENT(IN)</span>          :: time</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="keywordtype">    REAL</span>(KIND=dp),<span class="keywordtype">INTENT(IN)</span>    :: rcl(ntraj,n_dof)</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="keywordtype">COMPLEX(KIND=QP)</span>,<span class="keywordtype">INTENT(IN)</span> :: BOsigma(ntraj,nstates,nstates)</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keywordtype">CHARACTER(LEN=4)</span>            :: idx</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keywordtype">CHARACTER(LEN=400)</span>          :: filename</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keywordtype">INTEGER</span>                     :: itraj,ios</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160; </div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keyword">WRITE</span>(idx,<span class="stringliteral">&#39;(i4.4)&#39;</span>) time/dump</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    filename=trim(output_folder)//<span class="stringliteral">&quot;/coeff/coeff.&quot;</span>//trim(idx)//<span class="stringliteral">&quot;.dat&quot;</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160; </div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keyword">OPEN</span>(128,file=trim(filename),status=<span class="stringliteral">&quot;replace&quot;</span>, &amp;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;      form=<span class="stringliteral">&quot;formatted&quot;</span>,action=<span class="stringliteral">&quot;write&quot;</span>,iostat=ios)</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keywordflow">IF</span>(ios/=0) print*,<span class="stringliteral">&#39;error opening coefficients file&#39;</span></div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keyword">WRITE</span>(128,*) <span class="stringliteral">&quot;#Postion, Coefficients: Real part and Imaginary part&quot;</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <span class="keywordflow">DO</span> itraj=1,ntraj</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;      <span class="keyword">WRITE</span>(128,<span class="stringliteral">&#39;(100f14.8)&#39;</span>) rcl(itraj,:), &amp;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        (real(bosigma(itraj,:,:))),(aimag(bosigma(itraj,:,:)))</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="keywordflow">    END DO</span>    </div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160; </div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    <span class="keyword">CLOSE</span>(128)</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160; </div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;  <span class="keyword">END SUBROUTINE </span>plot_coefficients</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;  <span class="comment">! DESCRIPTION: Output subroutine for nuclear properties                     !</span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00161"></a><span class="lineno"><a class="line" href="namespaceoutput.html#ab306200f08bbb52e685f616adb4ed5ec">  161</a></span>&#160;  <span class="keyword">SUBROUTINE </span>plot_r_p_e(Rcl,Vcl,time)</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160; </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="keywordtype">INTEGER</span>      ,<span class="keywordtype">INTENT(IN)</span> :: time</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keywordtype">    REAL</span>(KIND=dp),<span class="keywordtype">INTENT(IN)</span> :: rcl(ntraj,n_dof), &amp;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;                                vcl(ntraj,n_dof)</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordtype">CHARACTER(LEN=4)</span>         :: idx</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    <span class="keywordtype">CHARACTER(LEN=400)</span>       :: filename</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="keywordtype">INTEGER</span>                  :: itraj,ios,counter</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160; </div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="keyword">WRITE</span>(idx,<span class="stringliteral">&#39;(i4.4)&#39;</span>) time/dump</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    filename=trim(output_folder)//<span class="stringliteral">&quot;/trajectories/RPE.&quot;</span>//trim(idx)//<span class="stringliteral">&quot;.dat&quot;</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="keyword">OPEN</span>(128,file=trim(filename),status=<span class="stringliteral">&quot;replace&quot;</span>, &amp;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;      form=<span class="stringliteral">&quot;formatted&quot;</span>,action=<span class="stringliteral">&quot;write&quot;</span>,iostat=ios)</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <span class="keywordflow">IF</span>(ios/=0) print*,<span class="stringliteral">&#39;error opening RPE file&#39;</span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <span class="keywordflow">IF</span> (typ_cal==<span class="stringliteral">&quot;TSHFS&quot;</span> .OR. typ_cal==<span class="stringliteral">&quot;TSHLZ&quot;</span>) <span class="keywordflow">THEN</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;       <span class="keyword">WRITE</span>(128,*) <span class="stringliteral">&quot;#Postions, Momenta, BOsurfaces, Running surface&quot;</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="keywordflow">ELSE</span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;      <span class="keyword">WRITE</span>(128,*) <span class="stringliteral">&quot;#Postions, Momenta, TDPES (GI part)&quot;</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="keywordflow">    END IF</span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160; </div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    filename=trim(output_folder)//<span class="stringliteral">&quot;/trajectories/occ_state.&quot;</span>//trim(idx)//<span class="stringliteral">&quot;.dat&quot;</span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <span class="keyword">OPEN</span>(138,file=trim(filename),status=<span class="stringliteral">&quot;replace&quot;</span>, &amp;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;      form=<span class="stringliteral">&quot;formatted&quot;</span>,action=<span class="stringliteral">&quot;write&quot;</span>,iostat=ios)</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keywordflow">IF</span>(ios/=0) print*,<span class="stringliteral">&#39;error opening occ_state file&#39;</span></div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160; </div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="keywordflow">DO</span> itraj=1,ntraj</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;       <span class="keywordflow">IF</span> (typ_cal==<span class="stringliteral">&quot;TSHLZ&quot;</span> .OR. typ_cal==<span class="stringliteral">&quot;TSHFS&quot;</span>) <span class="keywordflow">THEN</span></div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;          <span class="keyword">WRITE</span>(128,<span class="stringliteral">&#39;(200f14.6)&#39;</span>) rcl(itraj,:), mass(:) * vcl(itraj,:), &amp;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;              boenergy(itraj,occ_state(itraj)),boenergy(itraj,:),tdpes(itraj)</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;          <span class="keyword">WRITE</span>(138,<span class="stringliteral">&#39;(3i5)&#39;</span>) occ_state(itraj),lz_hop(itraj)</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;       <span class="keywordflow">ELSE</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;          <span class="keyword">WRITE</span>(128,<span class="stringliteral">&#39;(200f14.6)&#39;</span>) rcl(itraj,:),mass(:) * vcl(itraj,:),  &amp;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                 tdpes(itraj),boenergy(itraj,:),coup(itraj,1,2,:)</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="keywordflow">       END IF</span></div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="keywordflow">    END DO</span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160; </div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keyword">CLOSE</span>(128)</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    <span class="keyword">CLOSE</span>(138)</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160; </div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;  <span class="keyword">END SUBROUTINE </span>plot_r_p_e</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160; </div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;  <span class="comment">! DESCRIPTION: Calculation of the potential energy in Ehrenfest and CT-MQC  !</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00215"></a><span class="lineno"><a class="line" href="namespaceoutput.html#a3d2caef916d021721f8eb6529aac2b4f">  215</a></span>&#160;  <span class="keyword">SUBROUTINE </span>compute_energy(my_rho,e_BO,trajlabel)</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160; </div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keywordtype">INTEGER</span>         ,<span class="keywordtype">INTENT(IN)</span> :: trajlabel</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    <span class="keywordtype">COMPLEX(KIND=QP)</span>,<span class="keywordtype">INTENT(IN)</span> :: my_rho(nstates,nstates)</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;<span class="keywordtype">    REAL</span>(KIND=dp)   ,<span class="keywordtype">INTENT(IN)</span> :: e_bo(nstates)</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <span class="keywordtype">INTEGER</span>                     :: i</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160; </div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    tdpes(trajlabel)=0.0_dp</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160; </div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    <span class="keywordflow">DO</span> i=1,nstates</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;      tdpes(trajlabel)=tdpes(trajlabel)+ &amp;</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;<span class="keywordtype">        REAL</span>(my_rho(i,i),KIND=dp)*e_bo(i)</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="keywordflow">    END DO</span></div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160; </div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;  <span class="keyword">END SUBROUTINE </span>compute_energy</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160; </div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;  <span class="comment">! DESCRIPTION: Initialization of the output                                 !</span></div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00237"></a><span class="lineno"><a class="line" href="namespaceoutput.html#a86836a6f446885d459f048a9c0f393fb">  237</a></span>&#160;  <span class="keyword">SUBROUTINE </span>initialize_output</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160; </div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    <span class="keywordtype">INTEGER</span> :: ios</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160; </div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    <span class="keyword">OPEN</span>(88,file=trim(output_folder)//<span class="stringliteral">&quot;/BO_coherences.dat&quot;</span>,status=<span class="stringliteral">&quot;replace&quot;</span>, &amp;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;      form=<span class="stringliteral">&quot;formatted&quot;</span>,action=<span class="stringliteral">&quot;write&quot;</span>,iostat=ios)</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <span class="keywordflow">IF</span>(ios/=0) print*,<span class="stringliteral">&#39;error opening BO_coherences.dat&#39;</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    <span class="keyword">WRITE</span>(88,*) <span class="stringliteral">&quot;#Time, Coherences&quot;</span></div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160; </div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    <span class="keyword">open</span>(89,file=trim(output_folder)//<span class="stringliteral">&quot;/BO_population.dat&quot;</span>,status=<span class="stringliteral">&quot;replace&quot;</span>, &amp;</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;      form=<span class="stringliteral">&quot;formatted&quot;</span>,action=<span class="stringliteral">&quot;write&quot;</span>,iostat=ios)</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <span class="keywordflow">IF</span>(ios/=0) print*,<span class="stringliteral">&#39;error opening BO_population.dat&#39;</span></div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <span class="keyword">WRITE</span>(89,*) <span class="stringliteral">&quot;#Time, Populations&quot;</span></div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160; </div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;  <span class="keyword">END SUBROUTINE </span>initialize_output</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160; </div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;  <span class="comment">! DESCRIPTION: Finalization of the output                                   !</span></div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;  <span class="comment">!---------------------------------------------------------------------------!</span></div>
<div class="line"><a name="l00258"></a><span class="lineno"><a class="line" href="namespaceoutput.html#aaa0414cf8105658e81912a3a41d752cb">  258</a></span>&#160;  <span class="keyword">SUBROUTINE </span>finalize_output</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160; </div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    <span class="keyword">close</span>(89)</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <span class="keyword">close</span>(88)</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160; </div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;  <span class="keyword">END SUBROUTINE </span>finalize_output</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160; </div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;<span class="keyword">END module </span><a class="code" href="namespaceoutput.html">output</a></div>
<div class="ttc" id="anamespaceanalytical__potentials_html"><div class="ttname"><a href="namespaceanalytical__potentials.html">analytical_potentials</a></div><div class="ttdoc">Diabatic low dimensional potentials.</div><div class="ttdef"><b>Definition:</b> <a href="analytical__potentials_8f90_source.html#l00023">analytical_potentials.f90:23</a></div></div>
<div class="ttc" id="anamespacekinds_html"><div class="ttname"><a href="namespacekinds.html">kinds</a></div><div class="ttdoc">Definiton of kinds.</div><div class="ttdef"><b>Definition:</b> <a href="kinds_8f90_source.html#l00021">kinds.f90:21</a></div></div>
<div class="ttc" id="anamespaceoutput_html"><div class="ttname"><a href="namespaceoutput.html">output</a></div><div class="ttdoc">Output subroutines that print: electronic populations and coherences as functions of time; electronic...</div><div class="ttdef"><b>Definition:</b> <a href="output_8f90_source.html#l00024">output.f90:24</a></div></div>
<div class="ttc" id="anamespacevariables_html"><div class="ttname"><a href="namespacevariables.html">variables</a></div><div class="ttdoc">The module defines all common variables.</div><div class="ttdef"><b>Definition:</b> <a href="variables_8f90_source.html#l00021">variables.f90:21</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><b>output.f90</b></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
